/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.audit.action;

import java.util.Iterator;
import java.util.List;

import it.eng.console.audit.bo.ProcessInstanceBO;
import it.eng.spagosoa.metadb.model.LogJournal;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.action.AbstractAction;
import it.eng.spago.message.MessageBundle;

public class LogsJournalAction extends AbstractAction {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
			throws Exception {
		String idJournal = (String)serviceRequest.getAttribute("idJournal");
		int stateJournal = ProcessInstanceBO.getStateJournal(Long.parseLong(idJournal));
		SourceBean logJournalBean = new SourceBean("LIST");		
		List logsJournalList = ProcessInstanceBO.getLogsJournal(Long.parseLong(idJournal));					
		Iterator logsJournalIt = logsJournalList.iterator();
		SourceBean item = null;
		LogJournal logJournal = null;
		String stateLog = null;	
		String readonlyLog;
		while(logsJournalIt.hasNext()) {
			logJournal = (LogJournal)logsJournalIt.next();				
			item = new SourceBean("ITEM");
			item.setAttribute("idLog", logJournal.getIdLog());			
			
			//posso modificae solo un messaggio di input ovvero un mep di tipo ACTIVE 
			if ( ProcessInstanceBO.isFaultState(stateJournal) && ProcessInstanceBO.isActiveState(logJournal.getMepState().getIdState()))  
				readonlyLog = "FALSE";
			else
				readonlyLog = "TRUE";
			item.setAttribute("readonlyLog", readonlyLog);
			
			stateLog = Integer.toString(logJournal.getMepState().getIdState());
			item.setAttribute("stato", MessageBundle.getMessage(stateLog, "properties.console.console"));
			item.setAttribute("log", logJournal.getLog());								
			logJournalBean.setAttribute(item);					
		} 				
		serviceResponse.setAttribute(logJournalBean);
	}

}
