/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.audit.action;

import java.util.ArrayList;
import java.util.List;

import it.eng.console.process.bo.ProcessBO;
import it.eng.console.util.Constants;
import it.eng.spagosoa.metadb.base.ServiceAssemblyStateConstants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.dispatching.action.AbstractAction;

public class ProcessSearchAction extends AbstractAction {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
			throws Exception {
		List processList = ProcessBO.getProcessListOrderByName();
		serviceResponse.setAttribute("processo", processList);
			
		if (serviceRequest.getAttribute(Constants.LBL_BACKUP) == null) { 
			List processStateList = new ArrayList();
			if (serviceRequest.getAttribute(Constants.LBL_RESTART) == null) {
				processStateList.add(ServiceAssemblyStateConstants.SA_ACTIVE);
				processStateList.add(ServiceAssemblyStateConstants.SA_DONE);
			}
			processStateList.add(ServiceAssemblyStateConstants.SA_FAULTED);
			serviceResponse.setAttribute("statoprocesso", processStateList);
			List organizationList = null;
			if (((String)ConfigSingleton.getInstance().getAttribute("CONSOLE.taxonomyVisible")).equalsIgnoreCase("TRUE"))
				organizationList = ProcessBO.getAllOrganizations();
			else
				organizationList = new ArrayList();
			serviceResponse.setAttribute("orgList", organizationList);
			
			List iterList = ProcessBO.getIterList();
			serviceResponse.setAttribute("iterList", iterList);
		}	
		if (serviceRequest.getAttribute(Constants.LBL_RESTART) != null)
			serviceResponse.setAttribute(Constants.LBL_RESTART, serviceRequest.getAttribute(Constants.LBL_RESTART));
	}

}
