/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.audit.action;

import java.util.Iterator;
import java.util.List;

import it.eng.console.process.bo.RelevantDataBO;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.action.AbstractAction;

public class RelevantDataAction extends AbstractAction {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
			throws Exception {
		String idJournal = (String)serviceRequest.getAttribute("idJournal");
		List relevantDataList = RelevantDataBO.getRelevantData((new Long(idJournal)).longValue());
		Iterator relevantDataIt = relevantDataList.iterator();	
		SourceBean relevantBean = new SourceBean("RELEVANT_DATA");
		SourceBean data = null;	
		List attributeProperties;
		String catalog = null;
		while (relevantDataIt.hasNext()) {
			data = new SourceBean("DATA");
			attributeProperties = (List)relevantDataIt.next();
			data.setAttribute("attributo", attributeProperties.get(0));
			data.setAttribute("value", attributeProperties.get(1));
			catalog = (attributeProperties.get(2) != null)
					? (String)attributeProperties.get(2)
					: "";
			data.setAttribute("catalogo", catalog);
			relevantBean.setAttribute(data);
		}
		
		serviceResponse.setAttribute(relevantBean);							 				
	}

}
