/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.audit.action;

import java.util.Iterator;
import java.util.List;

import it.eng.console.process.bo.ProcessBO;
import it.eng.console.util.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;
import it.eng.spago.tracing.TracerSingleton;
import it.eng.spagosoa.metadb.model.Endpoint;

public class RelevantDataProcessAndComponentsAction extends
		RelevantDataProcessAndVersionAction {
	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
				throws Exception {
		String processId = (String)serviceRequest.getAttribute(Constants.LBL_PROCESS_ID);
		if(processId!=null) {
			//components
			serviceResponse.setAttribute(createComponentsBean(Long.parseLong(processId)));
			//process attributes
			SourceBean attributesBean = createProcessAttributeBean(Long.parseLong(processId));
			serviceResponse.setAttribute(attributesBean);
		}
	}
	
	private SourceBean createComponentsBean(long processId) {
		SourceBean componentsBean = null;
		try {
			componentsBean = new SourceBean("COMPONENTS");
			List componentsList = ProcessBO.getEndPointList(processId);
			Iterator componentsListIt = componentsList.iterator();		
			Endpoint component = null;
			SourceBean componentBean = null;
			while(componentsListIt.hasNext()) {
				component = (Endpoint)componentsListIt.next();
				componentBean = new SourceBean("COMPONENT");
				componentBean.setAttribute(Constants.LBL_ID_COMPONENT, component.getIdEndpoint());
				componentBean.setAttribute(Constants.LBL_NAME, component.getName());
				componentsBean.setAttribute(componentBean);					
			}
		} catch(SourceBeanException sbe) {
			TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "RelevantDataProcessAndCOmponentsAction::createComponentsBean():: ", sbe);
		}
		return componentsBean;
	}
}
