/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.audit.module;

import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.List;

import org.hibernate.Query;

import it.eng.console.audit.bo.ProcessInstanceBO;
import it.eng.console.audit.paginator.InstancesRestartedPaginator;
import it.eng.console.util.Constants;
import it.eng.spago.base.SessionContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.dispatching.action.AbstractAction;
import it.eng.spago.dispatching.module.AbstractModule;
import it.eng.spago.error.EMFErrorSeverity;
import it.eng.spago.error.EMFUserError;
import it.eng.spago.tracing.TracerSingleton;
import it.eng.spagosoa.smx.components.restart.client.RestartResult;
import it.eng.spagosoa.smx.components.restart.client.RestartServiceProxy;

public class RestartedInstancesPaginatorModule extends AbstractModule {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
			throws Exception {
		//
		SessionContainer sessionContainer = getRequestContainer().getSessionContainer();
		InstancesRestartedPaginator restartedPaginator = null;
		String pageRequested = (String)serviceRequest.getAttribute(Constants.PAGE_CMD);
		if( pageRequested == null) {
			long[] idOriginalList = (long[])serviceRequest.getAttribute("idOriginal");
			RestartResult[] idRestartedList = (RestartResult[])serviceRequest.getAttribute("idRestarted");
			restartedPaginator = new InstancesRestartedPaginator(idOriginalList, idRestartedList, Constants.sizeProcessInstanceListFiltered);
			sessionContainer.setAttribute("restartedPaginator", restartedPaginator);
		}
		else {
			restartedPaginator = (InstancesRestartedPaginator)sessionContainer.getAttribute("restartedPaginator");
			if(pageRequested.equalsIgnoreCase(Constants.FIRST_PAGE))
				restartedPaginator.setFirstPage();
			else if(pageRequested.equalsIgnoreCase(Constants.PREV_PAGE)) 
				restartedPaginator.setPrevPage();
			else if(pageRequested.equalsIgnoreCase(Constants.NEXT_PAGE)) 
				restartedPaginator.setNextPage();
		}
		
		//retrieve result complete
		serviceResponse.setAttribute("restartedBeanFE", restartedPaginator.getResult());
	}

}
