/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.listener;

import javax.servlet.http.HttpServletRequest;

import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.ResponseContainer;
import it.eng.spago.base.SessionContainer;
import it.eng.spago.event.ActionStartEvent;
import it.eng.spago.event.ISpagoEvent;
import it.eng.spago.listeners.ISpagoListener;

public class LanguageSettingListener implements ISpagoListener {

    public void onEvent(ISpagoEvent event, RequestContainer requestContainer,
            ResponseContainer responseContainer) {
        if ((event instanceof ActionStartEvent) ) {
        	String language = ((HttpServletRequest)requestContainer.getInternalRequest()).getHeader("accept-language");
            SessionContainer permanentContainer = requestContainer.getSessionContainer().getPermanentContainer();
            //devo salvare comunque la lingua altrimenti viene presa il default di common.xml
            if(language.startsWith("it")) {
        		permanentContainer.setAttribute("AF_LANGUAGE", "it");
        		permanentContainer.setAttribute("AF_COUNTRY", "IT");
            } else  {
            	permanentContainer.setAttribute("AF_LANGUAGE", "en");
        		permanentContainer.setAttribute("AF_COUNTRY", "US");
            }
        }
    }
}
