/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.process.action;

import java.util.Iterator;
import java.util.List;

import it.eng.console.audit.bo.ProcessInstanceBO;
import it.eng.console.process.bo.ProcessBO;
import it.eng.console.process.bo.RelevantDataBO;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.action.AbstractAction;

public class ProcessGraphAction extends AbstractAction {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse) throws Exception {
		String processId = (String)serviceRequest.getAttribute("processId");		
		String processInstanceId = (String)serviceRequest.getAttribute("processInstanceId");		
		String advancedSearch = ((String)serviceRequest.getAttribute("advancedSearch") != null)
								? (String)serviceRequest.getAttribute("advancedSearch")
								: "FALSE";
		String showRestarted = ((String)serviceRequest.getAttribute("showRestarted") != null)
								? (String)serviceRequest.getAttribute("showRestarted")
								: "FALSE";								
		String showRestartedMsg = ((String)serviceRequest.getAttribute("showRestartedMsg") != null)
								? (String)serviceRequest.getAttribute("showRestartedMsg")
								: "FALSE";							
		serviceResponse.setAttribute("processId",processId);
		serviceResponse.setAttribute("processName",ProcessBO.getProcessDetail((new Long(processId)).longValue()).getName());
		serviceResponse.setAttribute("advancedSearch",advancedSearch);
		serviceResponse.setAttribute("showRestarted",showRestarted);
		serviceResponse.setAttribute("showRestartedMsg",showRestartedMsg);
		
		if (processInstanceId!=null){
			serviceResponse.setAttribute("processInstanceId",processInstanceId);
			//state of instance process
			int state = ProcessInstanceBO.getStateInstanceProcess(Long.parseLong(processInstanceId));
			serviceResponse.setAttribute("state", state);
			//process relevant data
			List relevantDataList = RelevantDataBO.getAllRelevantData((new Long(processInstanceId)).longValue());
			Iterator relevantDataIt = relevantDataList.iterator();	
			SourceBean relevantBean = new SourceBean("RELEVANT_DATA");
			SourceBean data = null;	
			List attributeProperties;
			String catalog = null;
			while(relevantDataIt.hasNext()) {
				data = new SourceBean("DATA");
				attributeProperties = (List)relevantDataIt.next();
				data.setAttribute("attributo", attributeProperties.get(1));
				data.setAttribute("value", attributeProperties.get(2));
				catalog = (attributeProperties.get(3) != null)
							? (String)attributeProperties.get(3)
							: "";
				data.setAttribute("catalogo", catalog);
				relevantBean.setAttribute(data);
			}			
			serviceResponse.setAttribute(relevantBean);				
		}	
	}

}
