/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.tag;

import java.util.Iterator;
import java.util.List;
import java.util.Locale;

import it.eng.console.util.Constants;
import it.eng.spago.base.ResponseContainer;
import it.eng.spago.base.ResponseContainerAccess;
import it.eng.spago.tracing.TracerSingleton;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import javax.xml.registry.JAXRException;
import javax.xml.registry.infomodel.Organization;

public class OrganizationComboTag extends TagSupport {
	protected boolean _obligatorySelect = false;
	protected String _idSelect;
	
    public int doStartTag() throws JspException {
        TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "OrganizationComboTag::doStartTag:: invocato");
        if(pageContext == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL,
                "OrganizationComboTag::doStartTag:: pageContext nullo");
            throw new JspException("pageContext nullo");
        } 
        HttpServletRequest httpRequest = null;
        try {
            httpRequest = (HttpServletRequest) pageContext.getRequest();
        } catch(Exception ex) {
            TracerSingleton.log(
            		Constants.project, TracerSingleton.CRITICAL, "OrganizationComboTag::doStartTag::", ex);
            throw new JspException(ex.getMessage());
        } 
        if(httpRequest == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "OrganizationComboTag::doStartTag:: httpRequest nullo");
            throw new JspException("httpRequest nullo");
        } 
        ResponseContainer responseContainer =
            ResponseContainerAccess.getResponseContainer(httpRequest);
        if(responseContainer == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "OrganizationComboTag::doStartTag:: httpRequest nullo");
            throw new JspException("responseContainer nullo");
        } 
        StringBuffer output = new StringBuffer(); 
        output.append("<select name=\"" + _idSelect + "\" id=\"" + _idSelect + "\">\n");
        if(!_obligatorySelect)
        	output.append("<option value=\"\"></option>");
        
        List organizationList = (List)responseContainer.getServiceResponse().getAttribute("orgList");
        Iterator organizationListIt = organizationList.iterator();
        Organization organization = null;
        try {
	        while(organizationListIt.hasNext()) {
	        	organization = (Organization)organizationListIt.next();
	        	output.append("<option value=\"" + organization.getName().getValue(Locale.US).trim()+ "\">" + organization.getName().getValue(Locale.US)+ "</option>");													
	        }										
			output.append("</select>\n");	        	              
        } catch(JAXRException jax) {
        	TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "OrganizationComboTag::doStartTag::", jax);
            throw new JspException(jax.getMessage());
        }
        try {
            pageContext.getOut().print(output.toString());
        } catch(Exception ex) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "OrganizationComboTag::doStartTag::", ex);
            throw new JspException(ex.getMessage());
        } 
        return SKIP_BODY;
    } 
    
	public String getIdSelect() {
		return _idSelect;
	}

	public void setIdSelect(String idSelect) {
		_idSelect = idSelect;
	}

	public boolean isObligatorySelect() {
		return _obligatorySelect;
	}

	public void setObligatorySelect(boolean obligatorySelect) {
		_obligatorySelect = obligatorySelect;
	}

	/**
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag() throws JspException {
        TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "OrganizationComboTag::doEndTag:: invocato");
        return super.doEndTag();
    } 
}
