/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.test;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.criterion.Expression;
import org.hibernate.criterion.Order;

import it.eng.console.hibernate.util.HibernateSessionFactory;
import it.eng.spagosoa.metadb.model.InstanceSa;

public class TestHibernate {
	public static void main(String[] args) {
		Session session = HibernateSessionFactory.getSessionFactory().openSession();
		Criteria criteria = null;
		List processList = null;
		try {
			criteria = session.createCriteria(InstanceSa.class, "instanceSaAlias");
			criteria.addOrder(Order.desc("startdate"));	
			
			//**** join con relevantdata ****
			criteria = criteria.createCriteria("relevantDataInstanceSas", Criteria.LEFT_JOIN)
			.createCriteria("relevantData", Criteria.LEFT_JOIN);
			//**** join con attribute ****
			criteria = criteria.createCriteria("attribute", Criteria.LEFT_JOIN)
			.add(Expression.eq("orderCriteria", 0));
	
			processList = criteria.list();	
			System.out.println(processList.size());

		}catch(HibernateException he) {
			he.printStackTrace();
		}
	}
}
