/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.test;

import it.eng.console.hibernate.util.HibernateSessionFactory;
import it.eng.console.util.Constants;
import it.eng.spago.base.SourceBeanAttribute;
import it.eng.spago.tracing.TracerSingleton;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;

public class TestHibernate3 {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		List processList = new ArrayList();
		Session session = null;
		String startDate = "";
		String endDate = "";
		String process = "9";
		String org = "";
		String state = "";
		long idIterType = Constants.ALL_ITER;
		ArrayList iterAttributes = null;
		String orderby = "DATA";
		String orderType = "DESC";
		
		
		try {
				session = HibernateSessionFactory.getSessionFactory().openSession();
				Query query = null;
				//************ parsing date ************ 
				Date start = null;
				Date end = null;
				SimpleDateFormat simpleDateFormat = new SimpleDateFormat("dd/MM/yyyy");
				try {
					start = simpleDateFormat.parse(startDate);			
				} catch(Exception npe) {
					TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "ProcessInstanceBO::getProcessInstanceList:: startDate null");
				}
				try {			
					end = simpleDateFormat.parse(endDate);
				} catch(Exception npe) {
					TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "ProcessInstanceBO::getProcessInstanceList:: endDate null");
				}
				
				//*************  starting query ********************
				String hqlString = "SELECT new list(instanceSa.idInstanceSa, serviceAssembly.idAssembly, serviceAssembly.name, "; 
				if (idIterType != Constants.NO_ITER)
					hqlString +=" iterType.name,relevantData.value,";
				else 
					hqlString += " '','',";
				
				hqlString +=    " serviceAssembly.uddiOrg, instanceSa.startdate, instanceSa.enddate, instanceSa.state)"
								+ " FROM it.eng.spagosoa.metadb.model.ServiceAssembly serviceAssembly," 
								+ " it.eng.spagosoa.metadb.model.InstanceSa instanceSa ";
				
				//*****   join dati rilevanti per recuperare valore attributo che identifica istanza di iter ******
				hqlString += " LEFT OUTER JOIN instanceSa.relevantDataInstanceSas relevantDataInstanceSa"
				      + " LEFT OUTER JOIN  relevantDataInstanceSa.relevantData relevantData"
				      + " LEFT OUTER JOIN  relevantData.attribute attribute ";
				//********* join sull'istanza di iter *******
				if (idIterType == Constants.ALL_ITER) 
					hqlString +=  " LEFT OUTER JOIN instanceSa.instanceIter as instanceIter"
						+ " LEFT OUTER JOIN instanceIter.iterType as iterType";
				//iter selezionato
				else  if(idIterType != Constants.NO_ITER)				
					hqlString +=  " INNER JOIN instanceSa.instanceIter as instanceIter"
								+ " INNER JOIN instanceIter.iterType as iterType"
								+ " WITH iterType.idIterType = :idIterType";
					
				hqlString += " WHERE (attribute.orderCriteria IS NULL OR attribute.orderCriteria = 0)"
							+" AND (attribute IS NULL OR attribute.attributeCatalog.idCatalog = iterType.idCatalogCorrelation)";
				
				
				if(idIterType == Constants.NO_ITER)
					hqlString += " AND instanceSa.instanceIter IS NULL";
				
				//*********** fine join sull'istanza di iter ********
				
				hqlString += " AND serviceAssembly.idAssembly = instanceSa.serviceAssembly.idAssembly";
				
				if(process!=null && !process.equals(""))
					hqlString += " AND serviceAssembly.idAssembly = " + process;
				if(state!=null && !state.equals(""))
					hqlString += " AND instanceSa.state = " + state;
				if(start!=null) 					
					hqlString += " AND instanceSa.startdate >= :start_date";
				if(end!=null) 						
					hqlString += " AND instanceSa.enddate <= :end_date";
				if(org!=null && !org.equals(""))
					hqlString += " AND serviceAssembly.uddiOrg = :org";
				
				//condizione relative agli attributi di istanza di iter 
				if(iterAttributes != null && iterAttributes.size() > 0 ) {
					Iterator it = iterAttributes.iterator();
					SourceBeanAttribute attribute = null;
					long idAttribute;
					String valueAttribute;
					int prefixIndex = Constants.PREFIX_ATTRIBUTE.length();
					while(it.hasNext()) {
						attribute = (SourceBeanAttribute)it.next();
						idAttribute = (new Long(attribute.getKey().substring(prefixIndex))).longValue();
						valueAttribute = (String)attribute.getValue();
						hqlString += " AND EXISTS ( "
									+" FROM  it.eng.spagosoa.metadb.model.RelevantData relevantDataSubselect,"
									+" it.eng.spagosoa.metadb.model.RelevantDataInstanceSa relevantDataInstanceSubselect"
									+" WHERE relevantDataInstanceSubselect.relevantData.idRelevantData = relevantDataSubselect.idRelevantData"
									+" AND relevantDataSubselect.attribute.idAttribute = " + idAttribute 
									+" AND relevantDataSubselect.value like '%" + valueAttribute + "%'"
									+" AND relevantDataInstanceSubselect.instanceSa.idInstanceSa = instanceSa.idInstanceSa)";
					}
				}
				
				
				if(orderby!=null) {
					if(orderby.equalsIgnoreCase("DATA"))
						hqlString += " ORDER BY instanceSa.startdate " + orderType;
					else if(orderby.equalsIgnoreCase("OWNER"))
						hqlString += " ORDER BY serviceAssembly.uddiOrg " + orderType + ", instanceSa.startdate desc";
					else if(orderby.equalsIgnoreCase("PROCESS"))
						hqlString += " ORDER BY serviceAssembly.name " + orderType + ", instanceSa.startdate desc"; 
				}
				
				query = session.createQuery(hqlString);
				if(idIterType != Constants.ALL_ITER && idIterType != Constants.NO_ITER)
					query.setLong("idIterType", (new Long(idIterType)).longValue());
				if(start!=null)
					query.setDate("start_date", start);
				if(end!=null) 	
					query.setDate("end_date", end);
				if(org!=null && !org.equals(""))
					query.setString("org", org);
				processList = query.list();
			} catch(HibernateException he) {
				TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "ProcessInstanceBO::getProcessInstanceList:: ", he);
				throw he;
			}	
			

	System.out.println(processList.size());

	}

}
