/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.jmx.tag;

import java.util.Iterator;
import java.util.List;

import it.eng.console.util.Constants;
import it.eng.spago.base.ResponseContainer;
import it.eng.spago.base.ResponseContainerAccess;
import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.tracing.TracerSingleton;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

public class ServerComboTag extends TagSupport {	
	protected String _actionName = null;
	protected String _idSelect = null;
	protected String _idServerSelected = null;
	protected StringBuffer _outputHtml = null;
	protected HttpServletRequest httpRequest = null;
	
    public int doStartTag() throws JspException {
        TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "ServerComboTag::doStartTag:: invocato");
        if(pageContext == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL,
                "ServerComboTag::doStartTag:: pageContext nullo");
            throw new JspException("pageContext nullo");
        } 
        
        try {
            httpRequest = (HttpServletRequest) pageContext.getRequest();
        } catch(Exception ex) {
            TracerSingleton.log(
            		Constants.project, TracerSingleton.CRITICAL, "ServerComboTag::doStartTag::", ex);
            throw new JspException(ex.getMessage());
        } 
        if(httpRequest == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "ServerComboTag::doStartTag:: httpRequest nullo");
            throw new JspException("httpRequest nullo");
        } 
        
        ResponseContainer responseContainer =
            ResponseContainerAccess.getResponseContainer(httpRequest);
        if(responseContainer == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "ServerComboTag::doStartTag:: responseContainer nullo");
            throw new JspException("responseContainer nullo");
        }
        
        SourceBean serviceResponse= responseContainer.getServiceResponse();
        if(serviceResponse == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "ServerComboTag::doStartTag:: serviceResponse nullo");
            throw new JspException("serviceResponse nullo");
        }   
        _idServerSelected = (String)serviceResponse.getAttribute(it.eng.jmx.util.Constants.LBL_SELECTED_SERVER);
    	
    	generateForm();
        try {
            pageContext.getOut().print(_outputHtml.toString());
        } catch(Exception ex) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "ServerComboTag::doStartTag::", ex);
            throw new JspException(ex.getMessage());
        }
        return SKIP_BODY;
    } 
    
    private void generateForm() {
    	_outputHtml = new StringBuffer();
    	_outputHtml.append("<div class='div_detail_label'>\n");
    	_outputHtml.append("<span class='portlet-form-field-label'>Server</span>\n");
    	_outputHtml.append("</div>");
    	generateServerCombo();
		_outputHtml.append("</td>\n");
    }
    
    private void generateServerCombo() {
    	_outputHtml.append("<div class='div_detail_form'>\n");
    	_outputHtml.append("<select class='portlet-form-input-field' style='width:230px;' name=\"" + _idSelect + "\" id=\"" + _idSelect + "\"");
    	if (_actionName != null)
    		_outputHtml.append(" onchange=\"window.location='" + httpRequest.getContextPath() + "/" + _actionName + ".action?" + it.eng.jmx.util.Constants.LBL_SELECTED_SERVER + "='+this.value\">\n");
    	else
    		_outputHtml.append(">");
		ConfigSingleton config = ConfigSingleton.getInstance();
        List serverList = config.getAttributeAsList("SERVERS.SERVER");	
		Iterator serverListIt = serverList.iterator();
		SourceBean server = null;	
			
		while(serverListIt.hasNext()) {
			server = (SourceBean)serverListIt.next();
			if(_idServerSelected !=null && _idServerSelected.equalsIgnoreCase((String)server.getAttribute("id")))				
				_outputHtml.append("<option value=\"" + (String)server.getAttribute("id")+ "\" selected>" + (String)server.getAttribute("name") + "</option>");
			else 
				_outputHtml.append("<option value=\"" + (String)server.getAttribute("id") + "\">" + (String)server.getAttribute("name") + "</option>");
		}
		_outputHtml.append("</select>\n");
		_outputHtml.append("</div>\n");		
    }
    
	public String getIdSelect() {
		return _idSelect;
	}

	public void setIdSelect(String idSelect) {
		_idSelect = idSelect;
	}

	public String getActionName() {
		return _actionName;
	}

	public void setActionName(String actionName) {
		_actionName = actionName;
	}
	
	/**
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag() throws JspException {
        TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "IterTypeComboTag::doEndTag:: invocato");
        return super.doEndTag();
    }
}
